require "helpers"
local FlagsMatrix = {}

function FlagsMatrix:new(r, c)
	o = {n_rows=r, n_cols=c}
	for i=1,r do
		o[i] = {}
		for j=1,c do
			o[i][j] = {} 
		end
	end
	setmetatable(o, self)
	self.__index = self
	return o
end

function FlagsMatrix:set_flag(flag, i, j)
	print(i, j)
	o[i][j][flag] = true
end

function FlagsMatrix:unset_flag(flag, i, j)
	o[i][j][flag] = false
end

function FlagsMatrix:get_flag(flag, i, j)
	return o[i][j][flag]
end

function FlagsMatrix:copy(i, j, n, m)
	local new = FlagsMatrix:new(n, m)
	for x=1,n do
		for y=1,m do
			new[x][y] = shallowcopy(self[i+x-1][j+y-1])
		end
	end
	return new
end

function FlagsMatrix:print()
	for i=1,self.n_rows do
		io.write("R", i, ": \t")
		for j=1,self.n_cols do
			for k, v in pairs(self[i][j]) do
				io.write(k)
			end
			io.write(",\t")
		end
		io.write("\n")
	end
end

return FlagsMatrix

--[[a = FlagsMatrix:new(20, 20)
a:set_flag("hallo", 5, 5)
--a:print()
b = a:copy(4,4,3,3)
b:print()
print(b:get_flag("hallo", 1, 1))
print(b:get_flag("hallo", 2, 2))--]]