FlagsMatrix = require "flags_matrix"
Matrix = require "matrix"
require "math_helpers"

local function generate_world(config)
	tile_types = Matrix:new(config.world_width, config.world_height, 0)
	tile_flags = FlagsMatrix:new(config.world_width, config.world_height)
end

local function generate_water(config, tile_types, tile_flags)
	--some random places from which the seas will start to spread
	for i=1,config.n_seas do
		x = love.math.random(1,config.world_width)
		y = love.math.random(1,config.world_height)
		tile_types[x][y] = 1
		print(x, y)
		tile_flags:set_flag("water", x, y)
	end
	
	mask_size = 5 --needs to be uneven, a mask of size mask_size X mask_size will be used to determine how much water is around a specific tile
	world_width = config.world_width
	world_height = config.world_height
	for i=1,config.sea_iterations do
		for i=1,world_width do
			for j=1,world_height do
				--i,j is the tile we want to update
				--now check how much water is around
				local water_tiles_around = 0
				for k=1,mask_size do
					for l=1,mask_size do
						x = my_modulo(i-(mask_size+1)/2+k, world_width)
						y = my_modulo(j-(mask_size+1)/2+l, world_height)
						water_tiles_around = water_tiles_around + 1
					end
				end
				local relative_water_mass = water_tiles_around / (mask_size^2)
				if love.math.random() > relative_water_mass then
					tile_types[x][y] = 1
					tile_flags:set_flag("water", x, y)
				end
			end
		end
	end
end

return {
	generate_water = generate_water,
	generate_world = generate_world
}