local generation = require "world_generation"
local Area = require "area"
local configs = require "configs.world_config"

local World = {}

function World:new(config, chunk_width, chunk_height)
	assert(config.world_width % chunk_width == 0, "World width needs to be multiple of chunk width")
	assert(config.world_height % chunk_height == 0, "World height needs to be multiple of chunk height")
	w = {config=config, width=config.world_width, height=config.world_height, chunk_width=chunk_width, chunk_height=chunk_height}
	setmetatable(w, self)
	self.__index = self
	return w
end

function World:generate(config)
	config = self.config
	local tile_types = Matrix:new(config.world_width, config.world_height, "int8", 0)
	local tile_flags = FlagsMatrix:new(config.world_width, config.world_height)
	generation.generate_water(config, tile_types, tile_flags)
	n_chunks = self.width / self.chunk_width
	m_chunks = self.height / self.chunk_height
	self.areas = {}
	for i=0,n_chunks-1 do
		self.areas[i] = {}
		for j=0,m_chunks-1 do
			local area_tile_types = tile_types:copy(i*self.chunk_width+1, j*self.chunk_height+1, self.chunk_width, self.chunk_height)
			local area_tile_flags = tile_flags:copy(i*self.chunk_width+1, j*self.chunk_height+1, self.chunk_width, self.chunk_height)
			self.areas[i][j] = Areas:new(area_tile_types, area_tile_flags)
			--NEXT: Hier bin ich
		end
	end
end

return World